"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var recompose_1 = require("recompose");
var mapProps_1 = __importDefault(require("recompose/mapProps"));
var withStateHandlers_1 = __importDefault(require("recompose/withStateHandlers"));
var utils_1 = require("../../utils");
var betterRecompose_1 = require("./betterRecompose");
var URLDataSyncFactory = /** @class */ (function () {
    function URLDataSyncFactory() {
    }
    URLDataSyncFactory.prototype.callAPI = function (_a, callFn, successFn) {
        var setDataError = _a.setDataError, setIsLoadingData = _a.setIsLoadingData;
        return __awaiter(this, void 0, void 0, function () {
            var res, e_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        setDataError(undefined);
                        setIsLoadingData(true);
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, 4, 5]);
                        return [4 /*yield*/, callFn()];
                    case 2:
                        res = _b.sent();
                        successFn(res);
                        return [3 /*break*/, 5];
                    case 3:
                        e_1 = _b.sent();
                        setDataError(e_1);
                        return [3 /*break*/, 5];
                    case 4:
                        setIsLoadingData(false);
                        return [7 /*endfinally*/];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    URLDataSyncFactory.prototype.getData = function (props, additionalQuery) {
        var _this = this;
        var urlDataSync = props.urlDataSync, setData = props.setData;
        return this.callAPI(props, function () { return urlDataSync.get(additionalQuery); }, function (data) {
            _this.onDataChanged(props, data);
            setData(data);
        });
    };
    URLDataSyncFactory.prototype.onDataChanged = function (props, data) { };
    URLDataSyncFactory.prototype.newInstance = function () {
        var _this = this;
        return recompose_1.compose(withStateHandlers_1.default(function (_a) {
            var data = _a.initialData;
            return ({
                data: data,
                dataError: undefined,
                isLoadingData: false,
                urlQuery: {}
            });
        }, {
            setData: function () { return function (data) { return ({ data: data }); }; },
            setDataError: function () { return function (dataError) { return ({ dataError: dataError }); }; },
            setIsLoadingData: function () { return function (isLoadingData) { return ({ isLoadingData: isLoadingData }); }; },
            setURLQuery: function () { return function (urlQuery) { return ({ urlQuery: urlQuery }); }; }
        }), recompose_1.withHandlers({
            getData: function (props) { return function () { return _this.getData(props); }; },
            saveData: function (props) { return function () {
                var data = props.data, urlDataSync = props.urlDataSync, setData = props.setData;
                _this.callAPI(props, function () { return urlDataSync.update(data); }, setData);
            }; },
            updateData: function (props) { return function (newData) {
                var data = props.data, setData = props.setData;
                setData(Object.assign({}, data, newData));
            }; },
            updateURLQuery: function (props) { return function () {
                var queries = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    queries[_i] = arguments[_i];
                }
                return __awaiter(_this, void 0, void 0, function () {
                    var urlDataSync, setURLQuery;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                urlDataSync = props.urlDataSync, setURLQuery = props.setURLQuery;
                                setURLQuery(utils_1.mergeQueryMaps.apply(void 0, queries));
                                return [4 /*yield*/, urlDataSync.updateURLQuery.apply(urlDataSync, queries)];
                            case 1:
                                _a.sent();
                                return [4 /*yield*/, this.getData(props)];
                            case 2:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                });
            }; }
        }), betterRecompose_1.lifecycle({
            componentDidMount: function () {
                return __awaiter(this, void 0, void 0, function () {
                    var _a, urlDataSync, setURLQuery, query;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                _a = this.props, urlDataSync = _a.urlDataSync, setURLQuery = _a.setURLQuery;
                                return [4 /*yield*/, urlDataSync.getURLQuery()];
                            case 1:
                                query = _b.sent();
                                setURLQuery(query);
                                return [2 /*return*/];
                        }
                    });
                });
            }
        }));
    };
    return URLDataSyncFactory;
}());
/**
 * Automatically sync with current URL by requesting data from server using
 * said URL. This is assuming there is data provided by the server at current
 * URL, e.g. user navigates to /users/1, this will send a GET request to
 * /users/1, which should have a defined backend route that contains the
 * relevant data.
 *
 * This HOC is usually used for components rendered by a Route. Please make sure
 * when implementing the backend to handle these requests that it never returns
 * null/undefined (as per REST design standards).
 */
function urlDataSync() {
    return new URLDataSyncFactory().newInstance();
}
exports.urlDataSync = urlDataSync;
/**
 * This works with the auto-sync HOC to provide pagination state (but does not
 * trigger the sync). It is assumed that the server will return the data in the
 * above format - the cursor markers will be stored internally and fed the next
 * time we perform a GET request.
 */
function cursorPagination() {
    return recompose_1.compose(withStateHandlers_1.default({
        next: undefined,
        previous: undefined
    }, {
        setNext: function () { return function (next) { return ({ next: next }); }; },
        setPrevious: function () { return function (previous) { return ({ previous: previous }); }; }
    }));
}
exports.cursorPagination = cursorPagination;
var URLCursorPaginatedDataSyncFactory = /** @class */ (function (_super) {
    __extends(URLCursorPaginatedDataSyncFactory, _super);
    function URLCursorPaginatedDataSyncFactory() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    URLCursorPaginatedDataSyncFactory.prototype.onDataChanged = function (props, data) {
        var setNext = props.setNext, setPrevious = props.setPrevious;
        var next = data.next, previous = data.previous;
        setNext(next);
        setPrevious(previous);
        _super.prototype.onDataChanged.call(this, props, data);
    };
    URLCursorPaginatedDataSyncFactory.prototype.newInstance = function () {
        var _this = this;
        return recompose_1.compose(cursorPagination(), _super.prototype.newInstance.call(this), recompose_1.withHandlers({
            goToNextPage: function (props) { return function () {
                var next = props.next;
                _this.getData(props, { next: undefined, previous: next });
            }; },
            goToPreviousPage: function (props) { return function () {
                var previous = props.previous;
                _this.getData(props, { next: previous, previous: undefined });
            }; }
        }));
    };
    return URLCursorPaginatedDataSyncFactory;
}(URLDataSyncFactory));
/**
 * This HOC automatically manages pagination data sync, and is best used to
 * display table data. For other kinds of data use the data sync HOC.
 */
function urlCursorPaginatedDataSync() {
    return recompose_1.compose(mapProps_1.default(function (props) { return (__assign({ initialData: { results: [] } }, props)); }), new URLCursorPaginatedDataSyncFactory().newInstance(), mapProps_1.default(function (_a) {
        var data = _a.data.results, rest = __rest(_a, ["data"]);
        return (__assign({}, rest, { data: data }));
    }));
}
exports.urlCursorPaginatedDataSync = urlCursorPaginatedDataSync;
