/// <reference types="node" />
import querystring from "querystring";
/** Make an Array that can be sparse, i.e. have unfilled space. */
export declare function createSparseArray<T>(length: number, insertIndex: number, ...initialData: readonly T[]): readonly (T | undefined)[];
/**
 * Merge query maps into one big query map, concatenating values at common
 * keys together into an Array.
 */
export declare function mergeQueryMaps(...queries: readonly URLQueryMap[]): querystring.ParsedUrlQuery;
export declare function toArray<T>(value: T | readonly T[]): readonly T[];
//# sourceMappingURL=utils.d.ts.map